-----------------------------------
-- ESO_PARAMETRO --
-----------------------------------
CREATE TABLE ESO_PARAMETRO
(
	NRPARAMETRO		NUMBER		 	NOT NULL,
	DTINIVIGENCIA	DATE			NOT NULL,
	DTFIMVIGENCIA	DATE			NULL,
	NRESTRUTURAM	NUMBER        	NULL,
	DTTRANSMISSAO	DATE			NULL,
	DSVERSAO		VARCHAR2(10) 	NOT NULL,
	NRTPAMBIENTE	NUMBER        	NOT NULL,
	NRPARCNEGOCIO	NUMBER        	NOT NULL,
	DSARQUCERT		VARCHAR2(100)	NULL,
	DSSENHACERT		VARCHAR2(100)	NULL,
	DSARQUCERTKEY	VARCHAR2(100)	NULL,
	NRORG			NUMBER			NOT NULL,
	IDATIVO			VARCHAR2(1)		DEFAULT 'S' NOT NULL
		CONSTRAINT CKC_IDATIVO_ESO_PARAM CHECK (IDATIVO IN ('S','N')),
	DTINCLUSAO		DATE			NULL,
	DTULTATU		DATE			NULL,
	NRORGINCLUSAO	NUMBER			DEFAULT 1 NULL,
	CDOPERINCLUSAO	VARCHAR2(12)	DEFAULT '1' NULL,
	NRORGULTATU		NUMBER			DEFAULT 1 NULL,
	CDOPERULTATU	VARCHAR2(12)	DEFAULT '1',
	CONSTRAINT PK_ESO_PARAMETRO PRIMARY KEY (NRORG, NRPARAMETRO),
	CONSTRAINT FK_PARAMETRO_ESTRUTURA FOREIGN KEY (NRORG, NRESTRUTURAM)
	  REFERENCES ESTRUTURAM (NRORG, NRESTRUTURAM),
	CONSTRAINT FK_PARAMETRO_PARCNEGOCIO FOREIGN KEY (NRORG, NRPARCNEGOCIO)
	  REFERENCES PARCNEGOCIO (NRORG, NRPARCNEGOCIO)
)
/

-----------------------------------
-- ESO_ENVIOCADASTROS --
-----------------------------------
ALTER TABLE ESO_ENVIOCADASTROS ADD NRTPAMBIENTE NUMBER NULL
/
ALTER TABLE ESO_ENVIOCADASTROS ADD DTPROCESSAMENTO DATE NULL
/
ALTER TABLE ESO_ENVIOCADASTROS ADD DSOBSERVACAO2 VARCHAR2(1000) NULL
/