<?php
namespace Geral\Entities;

use Geral\Util\Ambiente;
use Geral\Util\DateUtil;

class Servoper extends Base\Servoper
{
    public static function deletaOperador($nrorg, $cdoperador)
    {
        try {
            $connection = \Setforms2\Shared\Registry::getEntityManager();
            $connection->beginTransaction();
            $registros = self::getObjectsByWhere(
                'NRORG = ? AND CDOPERADOR = ?', array($nrorg, $cdoperador)
            );
            foreach ($registros as $servoper) {
                $servoper->delete();
            }
            $connection->flush();
            $connection->commit();

            return true;
        } catch (\Exception $e) {
            $connection->rollback();
            throw $e;
        }
    }

    public static function deleta($nrorg, $operador, $filial, $servico){
        try{
            $servoper = self::getObjectByWhere(
                'NRORG = ? AND CDOPERADOR = ? AND CDFILIAL = ? AND CDSERVFILI = ?',
                array($nrorg, $operador, $filial, $servico)
            );
            if($servoper instanceof Servoper) {
                $connection = \Setforms2\Shared\Registry::getEntityManager();
                $connection->beginTransaction();

                $servoper->delete();

                $connection->flush();
                $connection->commit();
            }

            return true;
        } catch (\Exception $e) {
            $connection->rollback();
            throw $e;
        }
    }

    public static function insere($nrorg, $operador, $filial, $servico){
        try{
            $servoper = self::getObjectByWhere(
                'NRORG = ? AND CDOPERADOR = ? AND CDFILIAL = ? AND CDSERVFILI = ?',
                array($nrorg, $operador, $filial, $servico)
            );

            if(empty($servoper)) {
                $connection = \Setforms2\Shared\Registry::getEntityManager();
                $connection->beginTransaction();

                $servoper = new Servoper();
                $servoper->setCdoperador($operador);
                $servoper->setCdfilial($filial);
                $servoper->setCdservfili($servico);
                $servoper->setNrorg($nrorg);
                $servoper->setNrorginclusao($nrorg);
                $servoper->setNrorgultatu($nrorg);
                $servoper->setDtinclusao(DateUtil::getDataAtual());
                $servoper->setDtultatu(DateUtil::getDataAtual());
                $servoper->setCdoperinclusao(Ambiente::getCdOperador());
                $servoper->setCdoperultatu(Ambiente::getCdOperador());
                $servoper->persist();

                $connection->flush();
                $connection->commit();
            }

            return true;
        } catch (\Exception $e) {
            $connection->rollback();
            throw $e;
        }
    }
}